# 2012-01-03 For reading annotated trees as produced by TreeAnnotator.
# It will fail to read some nexus files containing tree(s).
# It is inefficient.


setwd("C:/AAA/Programming/Goteborg/simulation_di_tets_multigene")
# where this code is

source("AlloppSim_1readconfig2.r")


config.dir <- "C:/AAA/Programming/GoteborgSim/2011-12-29/net-mul-test-Bt"

analysis.info <- analysis.info.from.config.dir(config.dir)
all.files.prefix  <- analysis.info$all.files.prefix


config <- read.config2(paste(config.dir, "/", "config.txt", sep=""))



string.to.subtree <- function(txt, subtree) {
paren <- 0
brack <- 0
comma <- -1
closep <- -1
openp <- -1
for (i in 1:length(txt)) {
  if (txt[i] == "(") { paren <- paren + 1 }
  if (txt[i] == ")") { paren <- paren - 1 }
  if (txt[i] == "[") { brack <- brack + 1 }
  if (txt[i] == "]") { brack <- brack - 1 }
  stopifnot(brack <= 1)
  if (brack==0  &&  paren==1  &&  txt[i] == ",") {
    comma <- i
    }
  if (txt[i] == "(" &&  paren==1) {
    openp <- i
    }
  if (txt[i] == ")" &&  paren==0) {
    closep <- i
    }
  }
stopifnot((comma > 0  &&  closep > 0  &&  openp > 0)  ||  (comma < 0  &&  closep < 0  &&  openp < 0))

opbs <- which(txt=="[")
lastopb <- opbs[length(opbs)]
clbs <- which(txt=="]")
lastclb <- clbs[length(clbs)]
colons <- which(txt==":")
stopifnot(lastopb < lastclb)
brlen <- -1
if (length(colons) > 0) {
  lastcolon <- colons[length(colons)]
  if (lastcolon == lastclb+1) {
    brlen <- as.double(paste(txt[(lastcolon+1):length(txt)], sep="", collapse=""))
    } 
  }
annot <- paste(txt[(lastopb+1):(lastclb-1)], sep="", collapse="")

if (comma < 0) {  
  subtree <- c((subtree), list(list(node=txt[1:(lastopb-1)], brlen=brlen, annot=annot, lft=-1, rgt=-1)))
  } else {
  subtree <- string.to.subtree(txt[2:(comma-1)], subtree)
  lfti <- length(subtree)     
  subtree <- string.to.subtree(txt[(comma+1):(closep-1)], subtree)
  rgti <- length(subtree)  
  subtree <- c((subtree), list(list(node="", brlen=brlen, annot=annot, lft=lfti, rgt=rgti)))
  }
subtree
}               



string.from.nexus <- function(filepath) {
x <- scan(filepath, what="", sep="\n")
begin.trees.index <- grep("BEGIN TREES;", x=x, ignore.case=TRUE)
all.trees <- x[(begin.trees.index +1):length(x)]
end.trees.index <-  grep("END;|ENDBLOCK;", x=all.trees, ignore.case=TRUE)
all.trees <- all.trees[1:(end.trees.index-1)]
first.tree.index <- grep("TREE", x=all.trees, ignore.case=TRUE)
first.tree <- all.trees[first.tree.index]
tree.txt <- unlist(strsplit(first.tree, ""))
tree.txt
}



tree.txt <- string.from.nexus(fpath.mccmultree(config, 1, 1))
op <- which(tree.txt=="(")
sc <- which(tree.txt==";")
stopifnot(length(sc)==1)
txt <- tree.txt[op[1]:(sc-1)]
x <- string.to.subtree(txt, NULL)


nofnodes <- length(x)
nodes <- matrix(-1, nrow=nofnodes, ncol=5, dimnames=list(NULL,c("node", "lft", "rgt", "brlen", "posterior")))
for (i in 1:nofnodes) {
  if (nchar(x[[i]]$node) > 0) {
    ni <- as.integer(x[[i]]$node)
    } else {
    ni <- -1
    }
  nodes[i,1] <- ni
  nodes[i,2] <- as.integer(x[[i]]$lft)
  nodes[i,3] <- as.integer(x[[i]]$rgt)
  nodes[i,4] <- as.double(x[[i]]$brlen)
  vals <- unlist(strsplit(x[[i]]$annot, ","))
 
  p.i <- grep("posterior", vals)
  if (length(p.i) > 0) {
    print(vals[p.i])
    p.s <- substr(vals[p.i], 11, nchar(vals[p.i]))
    p.v <- as.double(p.s)
    } else {
    p.v <- -1
    }
  nodes[i,5] <- p.v 
  }

nodes







